//  RW Chibitsu
// ==============
// Cute, Smol, Animated Avatar & Robowaifu Library : Fairybot edition
// -Part of the RW Foundations suite of libraries

// Filename: ./include/chibitsu/chibitsu.hpp
// -Declarations of the baseline RW Chibitsu library

#pragma once

#include "incls_all.hpp"

namespace rw::chibitsu {

//------------------------------------------------------------------------------
class Chibitsu_b : public Arigato {
 public:
  Chibitsu_b();                                    // default ctor
  explicit Chibitsu_b(std::string const& handle);  // tag-parm'd ctor
};

//------------------------------------------------------------------------------
class Chibitsu : public Chibitsu_b {
 public:
  Chibitsu();                                    // default ctor
  explicit Chibitsu(std::string const& handle);  // tag-parm'd ctor

  inline auto graphicom() const -> Graphicom& { return graphicom_; }

 private:
  unique_ptr<Graphicom_b> _graphicom_{
      make_unique<Graphicom_b>("chibitsu_graphicom")};

  Graphicom& graphicom_{reference_to<Graphicom>(_graphicom_.get())};
};

}  // namespace rw::chibitsu

//    --=^=--

// "I can get my phone calls, go on the Internet, and get all my e-mail!"

// rw_chibitsu_lib.v211211
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
