//   RW Catalog
// ==============
// ______
// -Part of the RW Foundations suite of libraries

// Filename: ./include/curator/bumpmaster/catalog.hpp
// -Declarations of the baseline RW Catalog sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::curator::bumpmaster {

//------------------------------------------------------------------------------
class Catalog_b : public RW_slave {
 public:
  Catalog_b();                                    // default ctor
  explicit Catalog_b(std::string const& handle);  // tag-parm'd ctor

  auto parse_threads(Hip const& tag) -> int;  // guarded, for Master only
  auto have_new(Hip const& tag) -> bool;      //  "
};

//------------------------------------------------------------------------------
class Catalog : public Catalog_b {
 public:
  Catalog();                                    // default ctor
  explicit Catalog(std::string const& handle);  // tag-parm'd ctor
};

}  // namespace rw::curator::bumpmaster

//    --=^=--

// "______"

// rw_curator_lib.v211211
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
