//   RW Thread
// ==============
// ______
// -Part of the RW Foundations suite of libraries

// Filename: ./include/curator/bumpmaster/post.hpp
// -Declarations of the baseline RW Thread sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::curator::bumpmaster {

//------------------------------------------------------------------------------
class Thread_b : public RW_slave {
 public:
  Thread_b();                                    // default ctor
  explicit Thread_b(std::string const& handle);  // tag-parm'd ctor

  auto parse_posts(Hip const& tag) -> int;       // guarded, for Master only
  auto crosslink_posts(Hip const& tag) -> bool;  //  "
};

//------------------------------------------------------------------------------
class Thread : public Thread_b {
 public:
  Thread();                                    // default ctor
  explicit Thread(std::string const& handle);  // tag-parm'd ctor
};

}  // namespace rw::curator::bumpmaster

//    --=^=--

// "______"

// rw_curator_lib.v211211
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
