//   RW Arigato
// ==============
// aka 'Robowaifu' - The Humanoid Female Robot Companion Library
// -Part of the RW Foundations suite of libraries

// Filename: ./src/arigato/arigato.cpp
// -Definitions of the baseline RW Arigato library

#include "incls_all.hpp"

namespace rw::arigato {

//------------------------------------------------------------------------------
Arigato_b::Arigato_b() : Arigato_b{"arigato_b_obj"} {}

//------------------------------------------------------------------------------
Arigato_b::Arigato_b(std::string const& handle)
    : Arigato_b{handle, Type::Arigato} {}

//------------------------------------------------------------------------------
Arigato_b::Arigato_b(const std::string& handle, const Type type)
    : RW{handle, type} {
  stamp("Arigato_b()");
}

//------------------------------------------------------------------------------
Arigato::Arigato() : Arigato{"arigato_obj"} {}

//------------------------------------------------------------------------------
Arigato::Arigato(std::string const& handle)
    : Arigato_b{handle, Type::Arigato} {}

//------------------------------------------------------------------------------
Arigato::Arigato(const std::string& handle, const Type type)
    : Arigato_b{handle, type} {
  stamp("Arigato()");
}

//------------------------------------------------------------------------------
Arigato::~Arigato() {}

//------------------------------------------------------------------------------
auto Arigato::do_preflight() -> bool {
  // TODO:
  // do actual initialization here. eg, turn off embedded object's unneeded
  // members, ensure filesets are available & ready, connections are working,
  // etc., etc., etc.  :^)
  //

  printf("%s checks out A-OK!\n", hdl().c_str());
  return true;  // TEMP:
}

}  // namespace rw::arigato

//    --=^=--

// "I only wish I could find a really cute one lying around somewhere."

// rw_arigato_lib.v211211
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
