//   RW Catalog
// ==============
// ______
// -Part of the RW Foundations suite of libraries

// Filename: ./src/curator/bumpmaster/catalog.cpp
// -Definitions of the baseline RW Catalog sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::curator::bumpmaster {

//------------------------------------------------------------------------------
Catalog_b::Catalog_b() : Catalog_b{"catalog_b_obj"} {}

//------------------------------------------------------------------------------
Catalog_b::Catalog_b(std::string const& handle)
    : RW_slave{handle, {Type::Bumpmaster}} {
  stamp("Catalog_b()");
}

//------------------------------------------------------------------------------
auto Catalog_b::parse_threads(Hip const& tag /*, std::vector<Thread> threads*/)
    -> int {
  stamp(tag, "parse_threads()");

  if (tag == master()) {
    // TODO:
    // ...
    // threads.emplace_back(thrd);
    // ...

    // return threads.size();
    return 1;  // TEMP:
  } else
    only_master_can(master(), tag, t(), "Catalog_b::parse_threads()");

  ///
  return 9'001'42;  // shouldn't reach here
}

//------------------------------------------------------------------------------
auto Catalog_b::have_new(Hip const& tag /*, std::vector<Thread> threads*/)
    -> bool {
  stamp(tag, "have_new()");

  if (tag == master()) {
    // TODO:
    // ...

    return true;  // TEMP:
  } else
    only_master_can(master(), tag, t(), "Catalog_b::have_new()");

  ///
  return false;  // shouldn't reach here
}

//------------------------------------------------------------------------------
Catalog::Catalog() : Catalog{"catalog_obj"} {}

//------------------------------------------------------------------------------
Catalog::Catalog(std::string const& handle) : Catalog_b{handle} {
  stamp("Catalog()");
}

}  // namespace rw::curator::bumpmaster

//    --=^=--

// "______"

// rw_curator_lib.v211211
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
