//   RW Thread
// ==============
// ______
// -Part of the RW Foundations suite of libraries

// Filename: ./src/curator/bumpmaster/thread.cpp
// -Definitions of the baseline RW Thread sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::curator::bumpmaster {

//------------------------------------------------------------------------------
Thread_b::Thread_b() : Thread_b{"thread_b_obj"} {}

//------------------------------------------------------------------------------
Thread_b::Thread_b(std::string const& handle)
    : RW_slave{handle, {Type::Bumpmaster}} {
  stamp("Thread_b()");
}

//------------------------------------------------------------------------------
auto Thread_b::parse_posts(const Hip& tag /*, std::vector<Thread> posts*/)
    -> int {
  stamp(tag, "parse_posts()");

  if (tag == master()) {
    // TODO:
    // ...
    // posts.emplace_back(thrd);
    // ...

    // return posts.size();
    return 1;  // TEMP:
  } else
    only_master_can(master(), tag, t(), "Thread_b::parse_posts()");

  //
  return 9'001'42;  // shouldn't reach here
}

//------------------------------------------------------------------------------
auto Thread_b::crosslink_posts(Hip const& tag) -> bool {
  stamp(tag, "crosslink_posts()");

  if (tag == master()) {
    // TODO:
    // ...

    return true;  // TEMP:
  } else
    only_master_can(master(), tag, t(), "Thread_b::crosslink_posts()");

  ///
  return false;  // shouldn't reach here
}

//------------------------------------------------------------------------------
Thread::Thread() : Thread{"thread_obj"} {}

//------------------------------------------------------------------------------
Thread::Thread(std::string const& handle) : Thread_b{handle} {
  stamp("Thread()");
}

}  // namespace rw::curator::bumpmaster

//    --=^=--

// "______"

// rw_curator_lib.v211211
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
