//  RW Foundations
// ================
// The RW Foundational Libraries

// Filename: ./src/srcs_all.cpp
// -The following lines pull in the project's real *.cpp files.
// -note: this file also acts as a location for a few utility features

#include "rw/rw_srcs_all.cpp"
//
#include "action/action_srcs_all.cpp"
#include "animeyes/animeyes_srcs_all.cpp"
#include "arigato/arigato_srcs_all.cpp"
#include "atashi/atashi_srcs_all.cpp"
#include "bones/bones_srcs_all.cpp"
#include "chibitsu/chibitsu_srcs_all.cpp"
#include "curator/curator_srcs_all.cpp"
#include "dollhouse/dollhouse_srcs_all.cpp"
#include "electro/electro_srcs_all.cpp"
#include "gears/gears_srcs_all.cpp"
#include "graphicom/graphicom_srcs_all.cpp"
#include "hearsay/hearsay_srcs_all.cpp"
#include "meido/meido_srcs_all.cpp"
#include "shell/shell_srcs_all.cpp"

//------------------------------------------------------------------------------

#include "incls_all.hpp"

//------------------------------------------------------------------------------
void prt_tag(Hip const& tag, std::string const& msg) {
  Hdl_id hid{tag};

  cout << setw(32) << msg << " - " << dec << setw(24) << hid
       << "    \taddr:  " << setw(16) << hex << static_cast<void*>(tag.ptr)
       << '\n';
}

//------------------------------------------------------------------------------
void analyze_callgraph() {  //

  // load Callgraph:

  Callgraph cgraph{};

  for (const auto prw : RW_objs) {
    RW& rw_obj{reference_to<RW>(prw)};
    cgraph.emplace_back(RW_stamps{rw_obj.t(), rw_obj.get_stamps()});
  }

  ///
  puts("");

  // print Callgraph's items to console:

  cout << "Callgraph size (ie, the number of active RW objects) : "
       << cgraph.size() << "\n\n";

  for (auto& [out_tag, stamps] : cgraph) {  //
    Hdl_id out_hid{out_tag};

    cout << " - Object's Handle.ID : '" << out_hid << "'\n";
    cout << "\tobject's stampstack size : " << stamps.size() << "\n";

    while (! stamps.empty()) {  //

      auto [in_tag, func_nm, tim]{stamps.top()};
      Hdl_id in_hid{in_tag};

      cout << setw(24) << in_hid << setw(8)
           << ((in_hid == out_hid) ? "  (self)" : "") << setw(16)
           << " calls obj's : " << setw(21) << func_nm << " func at :  " << tim
           << '\n';

      stamps.pop();
    }

    puts("");
  }
}

//    --=^=--

// "So is it true Sempai? Are robowaifus really better than any human woman?"

// rw_foundations_lib.v211211
// Copyright (2021)
// License MIT(Expat) https://opensource.org/licenses/MIT
